Loading...
Searching...
No Matches
Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID > Class Template Reference

Calculator for phase saturations. More...

`#include <InitStateEquil.hpp>`

## Classes

struct | Position
| Evaluation point within a model geometry. More...

## Public Types

using | Scalar = typename FluidSystem::Scalar
using | PTable = PressureTable<FluidSystem, Region>
| Convenience type alias.

## Public Member Functions

| PhaseSaturations (MaterialLawManager &matLawMgr, const std::vector< Scalar > &swatInit)
| Constructor.
| PhaseSaturations (const PhaseSaturations &rhs)
| Copy constructor.
PhaseSaturations & | operator= (const PhaseSaturations &)=delete
| Disabled assignment operator.
PhaseSaturations & | operator= (PhaseSaturations &&)=delete
| Disabled move-assignment operator.
const PhaseQuantityValue< Scalar > & | deriveSaturations (const Position &x, const Region &reg, const PTable &ptable)
| Calculate phase saturations at particular point of the simulation model geometry.
const PhaseQuantityValue< Scalar > & | correctedPhasePressures () const
| Retrieve saturation-corrected phase pressures.

## Detailed Description

template<class MaterialLawManager, class FluidSystem, class Region, typename CellID>
class Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID >

Calculator for phase saturations.

Computes saturation values at arbitrary depths.

Template Parameters

  MaterialLawManager | Container for material laws. Typically a specialization of the Opm::EclMaterialLawManager<> template.
  FluidSystem | An OPM fluid system type. Typically a specialization of the Opm::BlackOilFluidSystem<> template.
  Region | Representation of an equilibration region. Typically Opm::EQUIL::EquilReg Opm::EQUIL::EquilReg Aggregate information base of an equilibration region. Definition EquilibrationHelpers.hpp:627 from the equilibrationhelpers.
  CellID | Representation an equilibration region's cell IDs. Typically std::size_t .

## Constructor & Destructor Documentation

## PhaseSaturations() [1/2]

template<class MaterialLawManager, class FluidSystem, class Region, typename CellID>

Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID >::PhaseSaturations | ( | MaterialLawManager & | matLawMgr,
|  | const std::vector< Scalar > & | swatInit )

explicit

Constructor.

Parameters

  [in,out] | matLawMgr | Read/write reference to a material law container. Mutated by member functions.
  [in] | swatInit | Initial water saturation array (from SWATINIT data). Empty if SWATINIT is not used in this simulation model.

## PhaseSaturations() [2/2]

template<class MaterialLawManager, class FluidSystem, class Region, typename CellID>

Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID >::PhaseSaturations | ( | const PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID > & | rhs | ) |

Copy constructor.

Parameters

  [in] | rhs | Source object.

## Member Function Documentation

## correctedPhasePressures()

template<class MaterialLawManager, class FluidSystem, class Region, typename CellID>

const PhaseQuantityValue< Scalar > & Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID >::correctedPhasePressures | ( |  | ) | const

inline

Retrieve saturation-corrected phase pressures.

Values associated with evaluation point of previous call to

deriveSaturations()
Opm::EQUIL::Details::PhaseSaturations::deriveSaturations
const PhaseQuantityValue< Scalar > & deriveSaturations(const Position &x, const Region &reg, const PTable &ptable)
Calculate phase saturations at particular point of the simulation model geometry.
Definition InitStateEquil_impl.hpp:596

.

## deriveSaturations()

template<class MaterialLawManager, class FluidSystem, class Region, typename CellID>

const PhaseQuantityValue< typename FluidSystem::Scalar > & Opm::EQUIL::Details::PhaseSaturations< MaterialLawManager, FluidSystem, Region, CellID >::deriveSaturations | ( | const Position & | x,
|  | const Region & | reg,
|  | const PTable & | ptable )

Calculate phase saturations at particular point of the simulation model geometry.

Parameters

  [in] | x | Specific geometric point (depth within a specific cell).
  [in] | reg | Equilibration information for a single equilibration region; notably contact depths.
  [in] | ptable | Previously equilibrated phase pressure table pertaining to the equilibration region `reg`.

Returns
  Set of phase saturation values defined at particular point.

The documentation for this class was generated from the following files:

- opm/simulators/flow/equil/InitStateEquil.hpp
- opm/simulators/flow/equil/InitStateEquil_impl.hpp